var DC930LApi = require('./lib/dc-930');
var _ = require('underscore');

module.exports = function(RED) {

  function DC930L(config) {
    RED.nodes.createNode(this, config);
    var node = this;
    this.command = config.command;
    this.camCredentials = RED.nodes.getNode(config.creds);

    this.on('input', function(msg) {
      var api = new DC930LApi(_(node.camCredentials).pick('host', 'port', 'username', 'password'));

      switch(node.command) {
        case 'enable_motion':
          api.enableMotionDetect()
            .then(function() {
              node.send(msg);
            }, function(err) {
              node.error(err);
            });
          break;
        case 'disable_motion':
          console.log('disabbla');
          api.disableMotionDetect()
            .then(function() {
              node.send(msg);
            }, function(err) {
              node.error(err);
            });
          break;
      }

    });
  }
  RED.nodes.registerType('dlink-930l', DC930L);

  function DC930LConfigNode(n) {
    RED.nodes.createNode(this, n);
    this.host = n.host;
    this.port = n.port;
    this.username = n.username;
    this.password = n.password;
  }
  RED.nodes.registerType('d930l-config-node', DC930LConfigNode);

};
