var fetch = require('node-fetch');
var request = require('request');
var _ = require('underscore');

module.exports = function(credentials) {

  credentials = _.extend({
    host: null,
    port: null,
    username: null,
    password: null
  }, credentials);

  function getCamAddress() {
    return 'http://' + credentials.username + ':' + credentials.password + '@' + credentials.host
      + (!_.isEmpty(credentials.port) ? ':' + credentials.port : '');
  }

  function getHeaders() {
    return {
      'Origin': getCamAddress(),
      'Content-Type': 'application/x-www-form-urlencoded',
      'Referer': 'http://' + credentials.host + (!_.isEmpty(credentials.port) ? ':' + credentials.port : '') + '/motion.htm',
      'Upgrade-Insecure-Requests': '1',
      'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8',
      'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.1 Safari/603.1.30'
    };
  }

  return {
    enableMotionDetect: function() {
      return new Promise(function(resolve, reject) {

        request.post({
          url: getCamAddress() + '/setSystemMotion',
          form: {
            'ReplySuccessPage': 'motion.htm',
            'ReplyErrorPage': 'motion.htm',
            'MotionDetectionEnable': '1',
            'MotionDetectionScheduleDay': '0',
            'MotionDetectionScheduleMode': '0',
            'MotionDetectionSensitivity': '30',
            'ConfigSystemMotion': 'Save'
          },
          headers: getHeaders()
        }, function (err, response, body) {
          if (err != null) {
            reject(err);
          } else {
            resolve();
          }
        });
      });
    },
    disableMotionDetect: function() {
      return new Promise(function(resolve, reject) {
        request.post({
          url: getCamAddress() + '/setSystemMotion',
          form: {
            'ReplySuccessPage': 'motion.htm',
            'ReplyErrorPage': 'motion.htm',
            'MotionDetectionEnable': '0',
            'MotionDetectionScheduleDay': '0',
            'ConfigSystemMotion': 'Save'
          },
          headers: getHeaders()
        }, function (err, body) {
          if (err != null) {
            reject(err);
          } else {
            resolve();
          }
        });
      });
    },
    getSnapshot: function() {

    }
  };

};
